#include <iostream>

using namespace std;

/* ------ datapoint class definition ------ */

class datapoint
{
 public:
    datapoint();                    // default constructor
    datapoint(float, float, string, string);  // parametered constructor
    void print() const;
 private:
    float x;
    float y;
    string color;
    string symbol;
};

/* ------ datapoint class implementation -------*/

  datapoint::datapoint() 
  {
  x = 0.0;
  y = 0.0;
  color = "black";
  symbol = "circle";
  }

  datapoint::datapoint(float px, float py, string pcolor, string psymbol)
  {
  x = px;
  y = py;
  color = pcolor;
  symbol = psymbol;
  }

  void datapoint::print() const
  {
  cout << x << " " << y << " " << color << " " << symbol << endl;
  }


/* ------ main -------*/

int main()
{
  datapoint A = datapoint();
  A.print();
  datapoint B = datapoint(0.1, 0.2, "red", "asterisk");
  B.print();

return 0;
}
