#!/usr/bin/perl

#----- Part A: named hashes

%datapoint1 = ( x => 0.0,
                y => 0.0,
                color => "black",
                symbol => "circle"
              );

%datapoint2 = ( x => 0.1,
                y => 0.2,
                color => "red",
                symbol => "asterisk"
              );

print "$datapoint1{color} \n";
print "$datapoint2{symbol} \n";
print " \n";

#----- Part B: named hash

@datapoints = (
               {
                x => "0.0",
                y => "0.0",
                color => "black",
                symbol => "circle"
               },
               {
                x => "0.0",
                y => "0.1",
                color => "red",
                symbol => "asterisk"
               }
            );

print $datapoints[0]{x}, "\n";
print $datapoints[0]{y}, "\n";
print $datapoints[0]{color}, "\n";
print $datapoints[0]{symbol}, "\n";
print " \n";

print $datapoints[1]{x}, "\n";
print $datapoints[1]{y}, "\n";
print $datapoints[1]{color}, "\n";
print $datapoints[1]{symbol}, "\n";
print " \n";

#----- Part C: anonymous hash

$tirith = [
               {
                x => "0.0",
                y => "0.2",
                color => "black",
                symbol => "circle"
               },
               {
                x => "0.3",
                y => "0.1",
                color => "maroon",
                symbol => "diamond"
               }
            ];

print $tirith->[0]{x}, "\n";
print $tirith->[0]{y}, "\n";
print $tirith->[0]{color}, "\n";
print $tirith->[0]{symbol}, "\n";
print $tirith->[1]{x}, "\n";
print $tirith->[1]{y}, "\n";
print $tirith->[1]{color}, "\n";
print $tirith->[1]{symbol}, "\n";
print " \n";

#----- Part D: anonymous hash

$graph = {
          datapoint => [
                    {
                     x => "1.0",
                     y => "3.0",
                     color => "black",
                     symbol => "circle"
                    },
                    {
                      x => "3.0",
                     ,y => "3.1",
                     ,color => "red",
                     ,symbol => "asterisk"
                    },
                       ]
        ,xlabel => "distance"
        ,ylabel => "temperature"
        ,title => "temperature distribution"
        };

print $graph->{datapoint}[0]{x},"\n";
print $graph->{datapoint}[0]{y},"\n";
print $graph->{datapoint}[0]{color},"\n";
print $graph->{datapoint}[0]{symbol},"\n";
print $graph->{datapoint}[1]{x},"\n";
print $graph->{datapoint}[1]{y},"\n";
print $graph->{datapoint}[1]{color},"\n";
print $graph->{datapoint}[1]{symbol},"\n";
print $graph->{xlabel},"\n";
print $graph->{ylabel},"\n";
print $graph->{title},"\n";
print " \n";

#----- Part E: fully named

%minas = (
            %pnt1 = (
                x => "0.0",
                y => "0.0",
                color => "black",
                symbol => "circle"
               ),

             %pnt2 = (
                x => "0.0",
                y => "0.1",
                color => "red",
                symbol => "asterisk"
               )
            );

print $minas->{pnt1}->{x},"\n";
