<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:template match="norm">
<html>

<!--- =============================== -->

  <xsl:for-each select="number">
     The absolute value of <xsl:value-of select="."/> is
     <xsl:call-template name="absolute">
        <xsl:with-param name="x" select="."/>
     </xsl:call-template>
    <br/>
  </xsl:for-each>

</html>
</xsl:template>

<!--- =============================== -->

<!-- user-defined function: absolute -->

<xsl:template name="absolute"> <xsl:param name="x"/>
 
    <xsl:choose>

    <xsl:when test="$x &gt; 0"> 
      <xsl:value-of select="$x"/>
    </xsl:when>

    <xsl:otherwise>
      <xsl:value-of select="-$x"/>
    </xsl:otherwise>
    </xsl:choose>

</xsl:template>

<!-- end of user-defined function -->

</xsl:stylesheet>
