<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:template match="touloumba">
<html>

<!-- 
  compute the maximum integer described by specified bits
  --> 

    <xsl:for-each select="nbits">
    <table cellpadding="1">
    <tr align="center"><th>bits-</th><th>-increment-</th>
                       <th>-largerst integer</th></tr>

      <xsl:call-template name="raise_add">
        <xsl:with-param name="nbits" select="."/>
        <xsl:with-param name="counter" select="1"/>
        <xsl:with-param name="increment" select="1"/>
        <xsl:with-param name="sum" select="1"/>
      </xsl:call-template>

    </table>
    </xsl:for-each>

</html>
</xsl:template>

<!-- user defined function -->

<xsl:template name="raise_add">
  <xsl:param name="nbits"/>
  <xsl:param name="counter"/>
  <xsl:param name="increment"/>
  <xsl:param name="sum"/>

  <xsl:if test="not($counter &gt; $nbits)">
    <tr align="center">
    <td><xsl:value-of select="$counter"/></td>
    <td><xsl:value-of select="$increment"/></td>
    <td><xsl:value-of select="$sum"/></td></tr>
  </xsl:if>

  <xsl:if test="$counter &lt; $nbits">
    <xsl:call-template name="raise_add">
      <xsl:with-param name="nbits" select="$nbits"/>
      <xsl:with-param name="counter" select="$counter + 1"/>
      <xsl:with-param name="increment" select="2 * $increment"/>
      <xsl:with-param name="sum" select="$sum + 2* $increment"/>
    </xsl:call-template>
  </xsl:if>

</xsl:template>

<!-- end of user-defined function -->

</xsl:stylesheet>
