<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:template match="roger">
<html>

 <xsl:for-each select="pair">
    The gratest common denominator of:
    <xsl:value-of select="int1"/>
    and <xsl:value-of select="int2"/> is:

      <xsl:call-template name="update">
        <xsl:with-param name="in1" select="int1"/>
        <xsl:with-param name="in2" select="int2"/>
      </xsl:call-template>

    </xsl:for-each>

</html>
</xsl:template>

<!-- user defined function: update -->

<xsl:template name="update">
  <xsl:param name="in1"/>
  <xsl:param name="in2"/>

  <xsl:choose>
  <xsl:when test="$in1 != $in2">

    <xsl:variable name="diff">
       <xsl:if test="$in1 &gt; $in2">
        <xsl:value-of select="$in1 - $in2"/>
       </xsl:if>
       <xsl:if test="$in1 &lt; $in2">
        <xsl:value-of select="$in2 - $in1"/>
       </xsl:if>
    </xsl:variable>
    <xsl:variable name="small">
       <xsl:if test="$in1 &gt; $in2">
         <xsl:value-of select="$in2"/>
       </xsl:if>
       <xsl:if test="$in1 &lt; $in2">
         <xsl:value-of select="$in1"/>
       </xsl:if>
    </xsl:variable>
    <xsl:call-template name="update">
      <xsl:with-param name="in1" select="$diff"/>
      <xsl:with-param name="in2" select="$small"/>
    </xsl:call-template>

  </xsl:when>
  <xsl:otherwise>
    <xsl:value-of select="$in1"/>
    <br/>
  </xsl:otherwise>
  </xsl:choose>

</xsl:template>

<!-- end of user defined function -->

</xsl:stylesheet>
