<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:variable name="a" select="1.0"/>
<xsl:variable name="b" select="1.0"/>

<xsl:template match="ouzo">
<html>

    <xsl:value-of select="number1"/>

      <xsl:call-template name="move">
        <xsl:with-param name="n1" select="number1"/>
        <xsl:with-param name="n2" select="number2"/>
        <xsl:with-param name="nterms" select="16"/>
      </xsl:call-template>

</html>
</xsl:template>

<!-- user defined function -->

<xsl:template name="move">
  <xsl:param name="n1"/>
  <xsl:param name="n2"/>
  <xsl:param name="nterms"/>

  <xsl:if test="$nterms > 1">

    - <xsl:value-of select="$n2"/>

    <xsl:call-template name="move">
      <xsl:with-param name="n1" select="$n2"/>
      <xsl:with-param name="n2" select="$a * $n1 + $b * $n2"/>
      <xsl:with-param name="nterms" select="$nterms - 1"/>
    </xsl:call-template>

  </xsl:if>

</xsl:template>

<!-- end of user defined function -->

</xsl:stylesheet>
