#!/usr/bin/perl
#
use XML::Simple;                           # use a module
use Data::Dumper;                          # use a module

@datapoint = ( 
                   {
                      x => "0.0",
                      y => "0.0",
                      color => "black",
                      symbol => "circle"
                    },
                    {
                      x => "0.0",
                      y => "0.1",
                      color => "red",
                      symbol => "asterisk"
                    }
            );

print $datapoint[0]->{x},"\n";
print $datapoint[0]->{color},"\n";

XMLout(\@datapoint,
      NoAttr => 1,
      KeepRoot   => 1, 
      OutputFile => 'datapoint.xml',
      RootName => 'points',
      XMLDecl    => "<?xml version='1.0'?>"
      );
