#!/usr/bin/perl
#
use XML::Simple;                           # use a module
use Data::Dumper;                          # use a module

$vivlia = {
      'mybooks' => 
      {
              'ncse' =>
                   {
                       'title'  => 'Numerical Computation in Science & Engineering',
                       'year'   => '2008',
                       'edition'  => '2',
                       'publisher' => 'OUP'
                   },
              'fem' =>
                   {
                       'title'  => 'Intro to Finite and Spectral Element Methods',
                       'year'   => '2005',
                       'edition'  => '1',
                       'publisher' => 'CRC'
                   }
      }
    };

print $vivlia->{mybooks}{ncse}{year},"\n";
print $vivlia->{mybooks}{fem}{year},"\n";

XMLout($vivlia, 
            KeepRoot   => 1, 
            NoAttr     => 1,
            XMLDecl    => "<?xml version='1.0'?>",
            OutputFile => 'vivlia.xml',
        );

print Dumper($vivlia);

