<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
xmlns:fem="femuri" 
xmlns:bem="bemuri"
>
<xsl:template match="laplace">
<html>

<!--- boundary elements -->

<xsl:for-each select="bem:grid">
 <xsl:for-each select="bem:element">
   One 
   <xsl:value-of select="@shape"/>
   boundary element with
   <xsl:value-of select="@nodes"/>
   nodes found
   (element index: <xsl:value-of select ="@id"/>)
   <br/>
 </xsl:for-each>
</xsl:for-each>

<br/>

<!--- finite elements -->

<xsl:for-each select="fem:grid">
 <xsl:for-each select="fem:element">
   One 
   <xsl:value-of select="@shape"/>
   finite element with
   <xsl:value-of select="@nodes"/>
   nodes found
   (element index: <xsl:value-of select ="@id"/>)
   <br/>
 </xsl:for-each>
</xsl:for-each>


<!--- done -->

</html>
</xsl:template>
</xsl:stylesheet>
