<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:template match="agio_oros">
<html>

<!-- 
  compute the binary representation of a number < 1
  to n bits
  --> 

 <xsl:for-each select="number">
    The binary representation of <xsl:value-of select="."/> is:
     0.<xsl:call-template name="reduce">
           <xsl:with-param name="x" select="2 *(. - floor(.))"/>
           <xsl:with-param name="n" select="10"/>
       </xsl:call-template> <br/>
 </xsl:for-each>

</html>
</xsl:template>

<!-- user-defined function -->

<xsl:template name="reduce">
  <xsl:param name="x"/>
  <xsl:param name="n"/>

  <xsl:if test="$n &gt; 0">
    <xsl:value-of select="floor($x)"/>
    <xsl:call-template name="reduce">
      <xsl:with-param name="x" select="2 * ($x - floor($x))"/>
      <xsl:with-param name="n" select="$n - 1"/>
    </xsl:call-template>
  </xsl:if>

</xsl:template>

<!-- end of user-defined function -->

</xsl:stylesheet>
