<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:template match="onoufrios">
<html>

<!-- 
  compute the integral power of a number
  --> 

    <xsl:for-each select="powint">
    <xsl:value-of select="base"/>^<xsl:value-of select="exponent"/>=
      <xsl:call-template name="raise">
        <xsl:with-param name="base" select="base"/>
        <xsl:with-param name="exponent" select="exponent"/>
        <xsl:with-param name="power" select="base"/>
      </xsl:call-template>
    <br/>
    </xsl:for-each>

</html>
</xsl:template>

<!-- User defined function -->

<xsl:template name="raise">
  <xsl:param name="base"/>
  <xsl:param name="exponent"/>
  <xsl:param name="power"/>

  <xsl:choose>
  <xsl:when test="$exponent &gt; 1">
    <xsl:call-template name="raise">
      <xsl:with-param name="base" select="$base"/>
      <xsl:with-param name="exponent" select="$exponent - 1"/>
      <xsl:with-param name="power" select="$power * $base"/>
    </xsl:call-template>
  </xsl:when>
  <xsl:otherwise>
    <xsl:value-of select="$power"/>
  </xsl:otherwise>
  </xsl:choose>

</xsl:template>

</xsl:stylesheet>
