<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:template match="sqrt">
<html>

    <xsl:for-each select="number">
      <xsl:call-template name="update">
        <xsl:with-param name="radical" select="."/>
        <xsl:with-param name="root" select="number(.) div 2"/>
        <xsl:with-param name="iteration" select="4"/>
      </xsl:call-template>
    </xsl:for-each>

</html>
</xsl:template>

<!-- user defined function -->

<xsl:template name="update">
  <xsl:param name="radical"/>
  <xsl:param name="root"/>
  <xsl:param name="iteration"/>

  <xsl:choose>

  <xsl:when test="$iteration &gt; 0">
    <xsl:call-template name="update">
      <xsl:with-param name="radical" select="$radical"/>
      <xsl:with-param name="root" select="($root + $radical div $root) div 2"/>
      <xsl:with-param name="iteration" select="$iteration - 1"/>
    </xsl:call-template>
  </xsl:when>

  <xsl:otherwise>
    <xsl:value-of select="$root"/><br/>
  </xsl:otherwise>

  </xsl:choose>
</xsl:template>

<!-- end of user defined function -->

</xsl:stylesheet>
