#include <iostream>
#include <fstream>
#include <iomanip>
#include <cmath>
using namespace std;

int main()
{
int i;
double step=0.1;

ofstream file1;
file1.open("exptab.xml");
file1 << setiosflags(ios::fixed | ios::showpoint);

file1 << "<?xml version='1.0' encoding='ISO-8859-1'?>" << endl;
file1 << "<?xml-stylesheet type='text/xsl' href='exptab.xsl'?>"
      << endl;
file1 << "<table>" << endl << endl;

for (i=1;i<=8;i++)
{
double x=(i-1.0)*step;
double y=exp(x);
file1 << "<entry id='" << i <<"'>" << endl;
file1 << "<x> " << setprecision(2) << setw(5) << x << "</x>  ";
file1 << "<y> " << setprecision(5) << setw(7) << y << "</y>  " << endl;
file1 << "</entry> " << endl;
}

file1 << "</table> " << endl;

file1.close();
return 0;
}
