<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">


<xsl:template match="/">
  <html>
  <body>
    <center>
    <h2>Boundary element discretization</h2>
    <table border="2" cellspacing="4" cellpadding="4">
      <tr bgcolor="olive">
        <th>Element</th>
        <th colspan="2">First Node</th>
        <th colspan="2">Second Node</th>
      </tr>
      <tr bgcolor="wheat">
        <th></th>
        <th>x</th>
        <th>y</th>
        <th>x</th>
        <th>y</th>
      </tr>
      <xsl:for-each select="grid/element">
      <tr bgcolor="ghostwhite" align="center">
        <td><xsl:value-of select="@id"/></td>
        <td><xsl:value-of select="node1/x"/></td>
        <td><xsl:value-of select="node1/y"/></td>
        <td><xsl:value-of select="node2/x"/></td>
        <td><xsl:value-of select="node2/y"/></td>
      </tr>
      </xsl:for-each>
    </table>
    </center>
  </body>
  </html>
</xsl:template>

</xsl:stylesheet>

