      program elm_line1_dr

c-----------------------------------------
c FDLIB
c
c Copyright by C. Pozrikidis, 1999
c All rights reserved.
c
c This program is to be used only under the
c stipulations of the licensing agreement.
c----------------------------------------

      Implicit Double Precision (a-h,o-z)

      Dimension Xe(129),Ye(129),se(129)
      Dimension Xm(128),Ym(128),sm(128)

c-----
c data
c-----

      X1 = 0.0D0
      Y1 = 0.0D0
      X2 = 1.0D0
      Y2 = 0.4D0
      N = 8
      ratio =2.0D0
      sinit=0.0D0

        call elm_line1
     +
     +   (N
     +   ,ratio
     +   ,X1,Y1
     +   ,X2,Y2
     +   ,sinit
     +   ,Xe,Ye,se
     +   ,Xm,Ym,sm
     +   )

c     write (6,*) (xe(i),i=1,N+1)
c     write (6,*) (ye(i),i=1,N+1)

c-----
c print xml
c-----

      open (1,file="elm_line1.xml")
   
      write (1,100)
      write (1,101)
      write (1,*)
      write (1,*) "<grid>"
      Do i=1,N
        write (1,*) ' <element id="',i,'">'
        write (1,*) '   <node1>'
        write (1,201) xe(i)
        write (1,202) ye(i)
        write (1,*) '   </node1>'
        write (1,*) '   <node2>'
        write (1,201) xe(i+1)
        write (1,202) ye(i+1)
        write (1,*) '   </node2>'
        write (1,*) " </element>"
      End Do
      write (1,*) "</grid>"
      close(1)

c-----
c Done
c-----

 100  Format('<?xml version="1.0" encoding="ISO-8859-1"?>')
 101  Format('<?xml-stylesheet type="text/xsl"href="elm_line1.xsl"?>')
 201  Format (10X,'<x>',f10.5,'</x>')
 202  Format (10X,'<y>',f10.5,'</y>')

      Stop
      End
