clear all

N = 3;

A=[ 1 3  4;
   -3 5  6;
   -3 1 -4];

eigval=eig(A);

file=fopen('eigen0.xml','w+');
fprintf(file,'<?xml version="1.0" encoding="ISO-8859-1"?>\n');
fprintf(file,'<?xml-stylesheet type="text/xsl"href="eigenvalues.xsl"?>\n');
fprintf(file,'<eigenvalues>\n\n');

for i=1:N
 fprintf(file,'<eigenvalue id="%2.0f">\n',i);
    fprintf(file,'\t<real>\n');
     fprintf(file, '\t\t%12.5f\n', real(eigval(i)));
    fprintf(file,'\t</real>\n');
    fprintf(file,'\t<imaginary>\n');
     fprintf(file, '\t\t%12.5f\n', imag(eigval(i)));
    fprintf(file,'\t</imaginary>\n');
 fprintf(file,'</eigenvalue>\n\n');
end

fprintf(file,'</eigenvalues>');
fclose(file);
