#!/usr/bin/perl                        
#
  use XML::Simple;                               # use a perl module
  use Data::Dumper;                              # use a perl module

# option A:
# -----------
  $arwin = XMLin("particles.xml", KeyAttr=>[]); 

# option B:
# -----------
#  $mol   = new XML::Simple;                     # create an object
#  $mol   = new XML::Simple(KeyAttr=>[]);        # create an object
#  $arwin = $mol->XMLin("molecules.xml");     # evaluate the object

  print Dumper($arwin);                         # print 

# second part
# -----------

  foreach $ind (@{$arwin->{molecule}})
  {
    print "The ",$ind->{name}," molecule has ",$ind->{atoms}," atoms\n";
  }

